#include "game.h"

int CGame::StretchNE(char *Filename, CDX *m_DX)
{
	int x=16;
	int y=SCN_SIZE_Y-12;
    
	//Displays logo coming at you
	m_DX->LoadBitmap(Filename,CDX_TILES,0,0);
	m_DX->ResizeTS(320,240);
	m_DX->FillArea(&CRect(0,0,SCN_SIZE_X,SCN_SIZE_Y),0,CDX_BACK);
	m_DX->FlipSurfaces();
	for(x=16;x<(SCN_SIZE_X-1);y-=12,x+=16)
	{
		m_DX->FillTexturedPoly(0,0,x,y,SCN_SIZE_X-1,SCN_SIZE_Y-1,0,SCN_SIZE_Y-1,0, CDX_TILES);
		m_DX->FlipSurfaces();
	}
	m_DX->FillTexturedPoly(0,0,SCN_SIZE_X-1,0,SCN_SIZE_X-1,SCN_SIZE_Y-1,0,SCN_SIZE_Y-1,0, CDX_TILES);
	m_DX->FlipSurfaces();
	m_DX->ResizeTS(32,32);

	return(TRUE);
}

//Displays the Tiny Logo
int CGame::DisplayTinyLogo(char *Filename, int x, int y, CDX *m_DX)
{
	m_DX->LoadBitmap(Filename,CDX_TILES,0,0);
	m_DX->ResizeTS(110,60);
	m_DX->FillTexturedPoly(x,y,x+100,y-10,x+60,y+40,x-5,y+30,0, CDX_TILES);
	m_DX->FlipSurfaces();
	m_DX->ResizeTS(32,32);
	return(TRUE);
}


int CGame::ChangeCurrentTile(char *CurrentTileSet, int SelectedTile, CPoint ClickPT)
{
	SelectedTile=(((ClickPT.y)/TILE_SIZE)*TILES_SCN_X)+(ClickPT.x/TILE_SIZE);
	return(SelectedTile);
}


//changes a tile (in the editor) to what the user clicks
int CGame::ChangeMapTile(CPoint ClickPT, int SelectedTile)
{
	Map[(ClickPT.x/TILE_SIZE)+User.x][(ClickPT.y/TILE_SIZE)+User.y].tile=SelectedTile;
	return(TRUE);
}

//Handles what key the user presses in the map window
void CGame::KeyHandle(UINT nChar, int UserStatus)
{

	switch(nChar)
	{
	
	case VK_UP:
		if(User.y>0)
		{
			if(UserStatus==MAINMAP)
			{
				if(Map[User.x+USER_OFFSET_X][User.y+USER_OFFSET_Y-1].tile==0)  //checks if the guy is on grass
				{
					User.y--;
					RandomHit=18;
				}
				else if(Map[User.x+USER_OFFSET_X][User.y+USER_OFFSET_Y-1].tile==42)  //checks if the guy is on desert
				{
					User.y--;
					RandomHit=8;
				}
			}
			else if(UserStatus==EDITOR)
				User.y--;
		}
		User.dir=0;
		break;
	case VK_DOWN:
		if(User.y<(MapSize.y-15))
		{
			if(UserStatus==MAINMAP)
			{
				if(Map[User.x+USER_OFFSET_X][User.y+USER_OFFSET_Y+1].tile==0)
				{
					User.y++;
					RandomHit=18;
				}
				else 
					if(Map[User.x+USER_OFFSET_X][User.y+USER_OFFSET_Y+1].tile==42)
				{
					User.y++;
					RandomHit=8;
				}
			}
			else if(UserStatus==EDITOR)
				User.y++;
		}
		User.dir=1;
		break;
	case VK_LEFT:
		if(User.x>0)
		{
			if(UserStatus==MAINMAP)
			{
				if(Map[User.x+USER_OFFSET_X-1][User.y+USER_OFFSET_Y].tile==0)
				{
					User.x--;
					RandomHit=18;
				}
				else if(Map[User.x+USER_OFFSET_X-1][User.y+USER_OFFSET_Y].tile==42)
				{
					User.x--;
					RandomHit=8;
				}
			}
			else if(UserStatus==EDITOR)
				User.x--;
		}
		User.dir=2;
		break;
	case VK_RIGHT:
		if(User.x<(MapSize.x-20))
		{
			if(UserStatus==MAINMAP)
			{
				if(Map[User.x+USER_OFFSET_X+1][User.y+USER_OFFSET_Y].tile==0)
				{
					User.x++;
					RandomHit=18;
				}
				else if(Map[User.x+USER_OFFSET_X+1][User.y+USER_OFFSET_Y].tile==42)
				{
					User.x++;
					RandomHit=8;
				}
			}
			else if(UserStatus==EDITOR)
				User.x++;
		}
		User.dir=3;
		break;
	}
}


int CGame::Fight(char *CurrentTileSet,CDX *m_DX)
{
//displays the fight border
	m_DX->LoadBitmap("bmp\\fight.bmp",CDX_TILES,0,0);
	m_DX->ResizeTS(320,240);
	m_DX->FillTexturedPoly(0,0,SCN_SIZE_X,0,SCN_SIZE_X,SCN_SIZE_Y,0,SCN_SIZE_Y,0,CDX_TILES);


//turns the tiles back to normal size and loads the normal tile set
	m_DX->ResizeTS(TILE_SIZE,TILE_SIZE);
	m_DX->LoadBitmap(CurrentTileSet,CDX_TILES,0,0);

//Displays the characters in their normal positions
	m_DX->FillTexturedPoly(432,32,464,32,464,64,432,64,22,CDX_TILES);	//Displays the first guy
	m_DX->FillTexturedPoly(432,96,464,96,464,128,432,128,22,CDX_TILES);	//Displays the second guy
	m_DX->FillTexturedPoly(432,160,464,160,464,192,432,192,22,CDX_TILES);	//Displays the third guy
	m_DX->FillTexturedPoly(432,224,464,224,464,256,432,256,22,CDX_TILES);	//Displays the fourth guy

//Displays the character names	
	m_DX->WriteText("Ted",464,32,1,CDX_BACK);
	m_DX->WriteText("53",528,32,1,CDX_BACK);
	m_DX->WriteText("24",528,48,1,CDX_BACK);

	m_DX->WriteText("Ed",464,96,1,CDX_BACK);
	m_DX->WriteText("34",528,96,1,CDX_BACK);
	m_DX->WriteText("16",528,112,1,CDX_BACK);

	m_DX->WriteText("Ned",464,160,1,CDX_BACK);
	m_DX->WriteText("1038",528,160,1,CDX_BACK);
	m_DX->WriteText("863",528,176,1,CDX_BACK);

	m_DX->WriteText("Sid",464,224,1,CDX_BACK);
	m_DX->WriteText("61",528,224,1,CDX_BACK);
	m_DX->WriteText("0",528,240,1,CDX_BACK);

//displays lower box message	
	m_DX->WriteText("Temporary fight scene",25,325,1,CDX_BACK);
	m_DX->WriteText("Press Q to return to the game",25,341,1,CDX_BACK);
	m_DX->FlipSurfaces();
	return(TRUE);
}


int CGame::CheckMonsterHit(CDX *m_DX)
{
	int Hit;  //our little random number variable
	int Fight;
	///This is the part that checks whether or not
	///the user is going to be attacked by a monster.
	Hit=rand()% RandomHit;  //Random hit generator...  RandomHit is defined pretty much by what the user is standing on
	if(Hit==1)  //if the random number is 1
		if(RecentHit>=6)  //if the user hasn't been hit in at least 8 moves.
		{
//			m_DX->CopyArea(&CRect(0,64,64,96),&CPoint(64,SCN_SIZE_Y-64),CDX_TILES,CDX_BACK);
			RecentHit=0;  //says the user can't be hit in another 8 moves
//			UserStatus=DISPLAYFIGHT;
			Fight=1;
		}
		else
		{
			m_DX->FillArea(&CRect(64,SCN_SIZE_Y-64,128,SCN_SIZE_Y-32),0,CDX_BACK);
			RecentHit++;  //adds one to the recent hit list :)
		}
	else
	{
		m_DX->FillArea(&CRect(64,SCN_SIZE_Y-64,128,SCN_SIZE_Y-32),0,CDX_BACK);
		RecentHit++;
	}
	if(Fight==1)
		return(TRUE);
	else
		return(FALSE);
}

//temporary!
void CGame::SetVariables()
{
	MapSize.x=1000;
	MapSize.y=1000;
}

//Constructor
CGame::CGame()  
{
	MapSize.x=1000;
	MapSize.y=1000;
	srand( (unsigned)time( NULL ) );
	MidStride=0;
	RecentHit=0;
	RandomHit=12;
}


//Destructor
CGame::~CGame()
{

}


//Loads the Map

int CGame::LoadMap(char *Filename)  
{
	CFile mapFile;
	if(!mapFile.Open(Filename, CFile::modeRead))
	{
		TRACE("* Couldn't open mapFile %s\n",Filename);
		return(FALSE);
	}
	mapFile.Read(&MapSize, sizeof(MapSize));
	mapFile.Read(&Map, sizeof(Map));
	mapFile.Close();
	User.x=MapSize.StartX;
	User.y=MapSize.StartY;
	User.dir=MapSize.StartDir;
	return(TRUE);
}


//creates a new map
int CGame::CreateNewMap(char *Filename)
{
	int a,b;
	for(a=0;a<1000;a++)
		for(b=0;b<1000;b++)
		{
			Map[a][b].flag=0;
			Map[a][b].tile=3
				;
	}
	return(TRUE);
}

//Saves the map file

int CGame::SaveEditorMap(char *Filename)  
{


	CFile mapFile;
	if(!mapFile.Open(Filename, CFile::modeWrite))
	{
		TRACE("* Couldn't save mapFile %s\n",Filename);
		return(FALSE);
	}
	mapFile.Write(&MapSize, sizeof(MapSize));
	mapFile.Write(&Map, sizeof(Map));
	mapFile.Close();
	return(TRUE);
}

//Loads the map tiles onto the tile surface
int CGame::LoadMapTiles(char *Filename, CDX *m_DX)
{
	m_DX->FillArea(&CRect(0,0,640,480),0,CDX_BACK);
	m_DX->LoadBitmap("bmp\\moutline.bmp",CDX_BACK,0,0);
	DisplayTinyLogo("bmp\\logotiny.bmp", 530, 420, m_DX);
	m_DX->LoadBitmap(Filename,CDX_TILES,0,0);
	return(TRUE);
}


//Redraws the Editor
int CGame::RedrawEditor(CDX *m_DX)
{
	int x,y,tilenum;
	int TileX,TileY;

	m_DX->FillArea(&CRect(0,0,SCN_SIZE_X,SCN_SIZE_Y),0,CDX_BACK);

	for(y=32;y<=480;y+=32){
		for(x=32;x<=640;x+=32){
			tilenum=Map[(x/32)+User.x-1][(y/32)+User.y-1].tile;
			TileX=(tilenum-((tilenum/TILES_SCN_X)*TILES_SCN_X))*TILE_SIZE;
			TileY=(tilenum/TILES_SCN_X)*TILE_SIZE;
			m_DX->CopyArea(&CRect(TileX,TileY,TileX+TILE_SIZE,TileY+TILE_SIZE),&CPoint(x-32,y-32),CDX_TILES,CDX_BACK);
		}
	}
	m_DX->ResizeTS(TILE_SIZE,TILE_SIZE);
	m_DX->FlipSurfaces();
	return(TRUE);

}


//Redraws the Map
int CGame::RedrawMap(CDX *m_DX)
{
	int x,y,tilenum;
	int TileX,TileY;

	for(y=32;y<=480;y+=32){
		for(x=32;x<=640;x+=32){
			tilenum=Map[(x/32)+User.x-1][(y/32)+User.y-1].tile;
			TileX=(tilenum-((tilenum/TILES_SCN_X)*TILES_SCN_X))*TILE_SIZE;
			TileY=(tilenum/TILES_SCN_X)*TILE_SIZE;
			m_DX->CopyArea(&CRect(TileX,TileY,TileX+TILE_SIZE,TileY+TILE_SIZE),&CPoint(x-32,y-32),CDX_TILES,CDX_WORK);
		}
	}
	m_DX->ResizeTS(SCN_SIZE_X,SCN_SIZE_Y);

		m_DX->FillTexturedPoly(100,100,SCN_SIZE_X-100,100,SCN_SIZE_X-1,SCN_SIZE_Y-100,0,SCN_SIZE_Y-100,0,CDX_WORK);


	switch(MidStride) {
	case 0:
		m_DX->CopyArea(&CRect((User.dir*TILE_SIZE),TILE_SIZE,(User.dir*TILE_SIZE)+TILE_SIZE,TILE_SIZE*2),&CPoint(335-16,234-16),CDX_TILES,CDX_BACK);
		MidStride=1;
		break;
	case 1:
		m_DX->CopyArea(&CRect((User.dir*TILE_SIZE+128),TILE_SIZE,(User.dir*TILE_SIZE)+128+TILE_SIZE,TILE_SIZE*2),&CPoint(335-16,234-16),CDX_TILES,CDX_BACK);
		MidStride=0;
		break;
	}
	m_DX->WriteText("Final Fantasy Zero",0,0,1,CDX_BACK);
	m_DX->WriteText("Version Alpha 4",0,16,1,CDX_BACK);

	m_DX->FlipSurfaces();
	m_DX->ResizeTS(TILE_SIZE,TILE_SIZE);
	return(TRUE);
}


//Fades Out about half way
int CGame::FadeOutHalf(char *Filename, CDX *m_DX)
{
	int x=SCN_SIZE_X/3;
	int y=SCN_SIZE_Y/3;
    
	m_DX->LoadBitmap(Filename,CDX_TILES,0,0);
	m_DX->ResizeTS(320,240);
//	m_DX->FillArea(&CRect(0,0,SCN_SIZE_X,SCN_SIZE_Y),0,CDX_BACK);
	m_DX->FlipSurfaces();
	for(y=SCN_SIZE_Y/3;y>3;y-=3,x-=4)
	{
		m_DX->FillArea(&CRect(0,0,SCN_SIZE_X,SCN_SIZE_Y),0,CDX_BACK);
		m_DX->FillTexturedPoly((SCN_SIZE_X/2)-x,(SCN_SIZE_Y/2)-y,(SCN_SIZE_X/2)+x,(SCN_SIZE_Y/2)-y,(SCN_SIZE_X/2)+x,(SCN_SIZE_Y/2)+y,(SCN_SIZE_X/2)-x,(SCN_SIZE_Y/2)+y,0, CDX_TILES);
		m_DX->FlipSurfaces();
	}
	m_DX->FillArea(&CRect(0,0,SCN_SIZE_X,SCN_SIZE_Y),0,CDX_BACK);
	m_DX->FlipSurfaces();
	m_DX->ResizeTS(32,32);
	return(TRUE);
}


//Fades In with a "twist"
int CGame::FadeInTwist(char *Filename, CDX *m_DX)
{
	int x=16;
	int y=12;
    
	m_DX->LoadBitmap(Filename,CDX_TILES,0,0);
	m_DX->ResizeTS(320,240);
	m_DX->FillArea(&CRect(0,0,SCN_SIZE_X,SCN_SIZE_Y),0,CDX_BACK);
	m_DX->FlipSurfaces();
	for(y=12;y<(SCN_SIZE_Y/3);y+=12,x+=16)
	{
		m_DX->FillTexturedPoly((SCN_SIZE_X/2)-x,(SCN_SIZE_Y/3)-y,(SCN_SIZE_X/2)+x,(SCN_SIZE_Y/2)-y,(SCN_SIZE_X/2)+x,(SCN_SIZE_Y/2)+y,(SCN_SIZE_X/2)-x,(SCN_SIZE_Y/3)+y,0, CDX_TILES);
		m_DX->FlipSurfaces();
	}
	m_DX->FillTexturedPoly(0,0,SCN_SIZE_X,0,SCN_SIZE_X,SCN_SIZE_Y,0,SCN_SIZE_Y,0, CDX_TILES);
	m_DX->FlipSurfaces();
	m_DX->ResizeTS(32,32);
	return(TRUE);
}

//Fades In about half way
int CGame::FadeInHalf(char *Filename, CDX *m_DX)
{
	int x=4;
	int y=3;
    
	m_DX->FillArea(&CRect(0,0,SCN_SIZE_X,SCN_SIZE_Y),0,CDX_BACK);
	m_DX->FlipSurfaces();
	m_DX->LoadBitmap(Filename,CDX_TILES,0,0);
	m_DX->ResizeTS(320,240);
//	m_DX->FillArea(&CRect(0,0,SCN_SIZE_X,SCN_SIZE_Y),0,CDX_BACK);
	m_DX->FlipSurfaces();
	for(y=3;y<(SCN_SIZE_Y/3);y+=3,x+=4)
	{
		m_DX->FillTexturedPoly((SCN_SIZE_X/2)-x,(SCN_SIZE_Y/2)-y,(SCN_SIZE_X/2)+x,(SCN_SIZE_Y/2)-y,(SCN_SIZE_X/2)+x,(SCN_SIZE_Y/2)+y,(SCN_SIZE_X/2)-x,(SCN_SIZE_Y/2)+y,0, CDX_TILES);
		m_DX->FlipSurfaces();
	}
	m_DX->ResizeTS(32,32);
	return(TRUE);
}




//Fades In
int CGame::FadeIn(char *Filename, CDX *m_DX)
{
	int x=4;
	int y=3;
    
	m_DX->LoadBitmap(Filename,CDX_TILES,0,0);
	m_DX->ResizeTS(320,240);
	m_DX->FillArea(&CRect(0,0,SCN_SIZE_X,SCN_SIZE_Y),0,CDX_BACK);
	m_DX->FlipSurfaces();
	for(y=3;y<(SCN_SIZE_Y/2);y+=3,x+=4)
	{
		m_DX->FillTexturedPoly((SCN_SIZE_X/2)-x,(SCN_SIZE_Y/2)-y,(SCN_SIZE_X/2)+x,(SCN_SIZE_Y/2)-y,(SCN_SIZE_X/2)+x,(SCN_SIZE_Y/2)+y,(SCN_SIZE_X/2)-x,(SCN_SIZE_Y/2)+y,0, CDX_TILES);
		m_DX->FlipSurfaces();
	}
	m_DX->ResizeTS(32,32);
	return(TRUE);
}

//Fades Out
int CGame::FadeOut(char *Filename, CDX *m_DX)
{
	int x=SCN_SIZE_X/2;
	int y=SCN_SIZE_Y/2;
    
	m_DX->LoadBitmap(Filename,CDX_TILES,0,0);
	m_DX->ResizeTS(320,240);
//	m_DX->FillArea(&CRect(0,0,SCN_SIZE_X,SCN_SIZE_Y),0,CDX_BACK);
	m_DX->FlipSurfaces();
	for(y=SCN_SIZE_Y/2;y>3;y-=3,x-=4)
	{
		m_DX->FillArea(&CRect(0,0,SCN_SIZE_X,SCN_SIZE_Y),0,CDX_BACK);
		m_DX->FillTexturedPoly((SCN_SIZE_X/2)-x,(SCN_SIZE_Y/2)-y,(SCN_SIZE_X/2)+x,(SCN_SIZE_Y/2)-y,(SCN_SIZE_X/2)+x,(SCN_SIZE_Y/2)+y,(SCN_SIZE_X/2)-x,(SCN_SIZE_Y/2)+y,0, CDX_TILES);
		m_DX->FlipSurfaces();
	}
	m_DX->FillArea(&CRect(0,0,SCN_SIZE_X,SCN_SIZE_Y),0,CDX_BACK);
	m_DX->FlipSurfaces();
	m_DX->ResizeTS(32,32);
	return(TRUE);
}
